"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from clerk_backend_api.types import BaseModel
from clerk_backend_api.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ListWaitlistEntriesQueryParamStatus(str, Enum):
    r"""Filter waitlist entries by their status"""

    PENDING = "pending"
    INVITED = "invited"
    COMPLETED = "completed"
    REJECTED = "rejected"


class ListWaitlistEntriesRequestTypedDict(TypedDict):
    limit: NotRequired[int]
    r"""Applies a limit to the number of results returned.
    Can be used for paginating the results together with `offset`.
    """
    offset: NotRequired[int]
    r"""Skip the first `offset` results when paginating.
    Needs to be an integer greater or equal to zero.
    To be used in conjunction with `limit`.
    """
    query: NotRequired[str]
    r"""Filter waitlist entries by `email_address` or `id`"""
    status: NotRequired[ListWaitlistEntriesQueryParamStatus]
    r"""Filter waitlist entries by their status"""
    order_by: NotRequired[str]
    r"""Specify the order of results. Supported values are:
    - `created_at`
    - `email_address`
    - `invited_at`

    Use `+` for ascending or `-` for descending order. Defaults to `-created_at`.
    """


class ListWaitlistEntriesRequest(BaseModel):
    limit: Annotated[
        Optional[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = 10
    r"""Applies a limit to the number of results returned.
    Can be used for paginating the results together with `offset`.
    """

    offset: Annotated[
        Optional[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = 0
    r"""Skip the first `offset` results when paginating.
    Needs to be an integer greater or equal to zero.
    To be used in conjunction with `limit`.
    """

    query: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Filter waitlist entries by `email_address` or `id`"""

    status: Annotated[
        Optional[ListWaitlistEntriesQueryParamStatus],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Filter waitlist entries by their status"""

    order_by: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = "-created_at"
    r"""Specify the order of results. Supported values are:
    - `created_at`
    - `email_address`
    - `invited_at`

    Use `+` for ascending or `-` for descending order. Defaults to `-created_at`.
    """
