"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .organizationmembershippublicuserdata import (
    OrganizationMembershipPublicUserData,
    OrganizationMembershipPublicUserDataTypedDict,
)
from clerk_backend_api.types import BaseModel
from enum import Enum
from typing import Any, Dict, List, Optional
from typing_extensions import NotRequired, TypedDict


class OrganizationMembershipObject(str, Enum):
    r"""String representing the object's type. Objects of the same type share the same value."""

    ORGANIZATION_MEMBERSHIP = "organization_membership"


class OrganizationMembershipOrganizationObject(str, Enum):
    ORGANIZATION = "organization"


class OrganizationMembershipOrganizationTypedDict(TypedDict):
    object: OrganizationMembershipOrganizationObject
    id: str
    name: str
    slug: str
    max_allowed_memberships: int
    admin_delete_enabled: bool
    public_metadata: Dict[str, Any]
    private_metadata: Dict[str, Any]
    created_at: int
    r"""Unix timestamp of creation.

    """
    updated_at: int
    r"""Unix timestamp of last update.

    """
    members_count: NotRequired[int]
    missing_member_with_elevated_permissions: NotRequired[bool]
    pending_invitations_count: NotRequired[int]
    created_by: NotRequired[str]


class OrganizationMembershipOrganization(BaseModel):
    object: OrganizationMembershipOrganizationObject

    id: str

    name: str

    slug: str

    max_allowed_memberships: int

    admin_delete_enabled: bool

    public_metadata: Dict[str, Any]

    private_metadata: Dict[str, Any]

    created_at: int
    r"""Unix timestamp of creation.

    """

    updated_at: int
    r"""Unix timestamp of last update.

    """

    members_count: Optional[int] = None

    missing_member_with_elevated_permissions: Optional[bool] = None

    pending_invitations_count: Optional[int] = None

    created_by: Optional[str] = None


class OrganizationMembershipTypedDict(TypedDict):
    r"""Hello world"""

    id: str
    object: OrganizationMembershipObject
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    role: str
    permissions: List[str]
    public_metadata: Dict[str, Any]
    r"""Metadata saved on the organization membership, accessible from both Frontend and Backend APIs"""
    organization: OrganizationMembershipOrganizationTypedDict
    created_at: int
    r"""Unix timestamp of creation."""
    updated_at: int
    r"""Unix timestamp of last update."""
    role_name: NotRequired[str]
    private_metadata: NotRequired[Dict[str, Any]]
    r"""Metadata saved on the organization membership, accessible only from the Backend API"""
    public_user_data: NotRequired[OrganizationMembershipPublicUserDataTypedDict]
    r"""An organization membership with public user data populated"""


class OrganizationMembership(BaseModel):
    r"""Hello world"""

    id: str

    object: OrganizationMembershipObject
    r"""String representing the object's type. Objects of the same type share the same value.

    """

    role: str

    permissions: List[str]

    public_metadata: Dict[str, Any]
    r"""Metadata saved on the organization membership, accessible from both Frontend and Backend APIs"""

    organization: OrganizationMembershipOrganization

    created_at: int
    r"""Unix timestamp of creation."""

    updated_at: int
    r"""Unix timestamp of last update."""

    role_name: Optional[str] = None

    private_metadata: Optional[Dict[str, Any]] = None
    r"""Metadata saved on the organization membership, accessible only from the Backend API"""

    public_user_data: Optional[OrganizationMembershipPublicUserData] = None
    r"""An organization membership with public user data populated"""
