"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from clerk_backend_api import utils
from clerk_backend_api.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from clerk_backend_api.utils import validate_open_enum
from enum import Enum
from pydantic import model_serializer
from pydantic.functional_validators import PlainValidator
from typing import Any, Dict, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class SAMLAccountObject(str, Enum):
    r"""String representing the object's type. Objects of the same type share the same value."""

    SAML_ACCOUNT = "saml_account"


class TicketVerificationSAMLAccountStatus(str, Enum):
    UNVERIFIED = "unverified"
    VERIFIED = "verified"
    EXPIRED = "expired"


class TicketVerificationSAMLAccountStrategy(str, Enum, metaclass=utils.OpenEnumMeta):
    TICKET = "ticket"


class VerificationTicketTypedDict(TypedDict):
    status: TicketVerificationSAMLAccountStatus
    strategy: TicketVerificationSAMLAccountStrategy
    attempts: Nullable[int]
    expire_at: Nullable[int]
    verified_at_client: NotRequired[Nullable[str]]


class VerificationTicket(BaseModel):
    status: TicketVerificationSAMLAccountStatus

    strategy: Annotated[
        TicketVerificationSAMLAccountStrategy, PlainValidator(validate_open_enum(False))
    ]

    attempts: Nullable[int]

    expire_at: Nullable[int]

    verified_at_client: OptionalNullable[str] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["verified_at_client"]
        nullable_fields = ["attempts", "expire_at", "verified_at_client"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class SAMLVerificationStatus(str, Enum):
    UNVERIFIED = "unverified"
    VERIFIED = "verified"
    FAILED = "failed"
    EXPIRED = "expired"
    TRANSFERABLE = "transferable"


class SAMLVerificationStrategy(str, Enum):
    SAML = "saml"


class ClerkErrorErrorSAMLAccountMetaTypedDict(TypedDict):
    pass


class ClerkErrorErrorSAMLAccountMeta(BaseModel):
    pass


class SAMLErrorClerkErrorTypedDict(TypedDict):
    message: str
    long_message: str
    code: str
    meta: NotRequired[ClerkErrorErrorSAMLAccountMetaTypedDict]
    clerk_trace_id: NotRequired[str]


class SAMLErrorClerkError(BaseModel):
    message: str

    long_message: str

    code: str

    meta: Optional[ClerkErrorErrorSAMLAccountMeta] = None

    clerk_trace_id: Optional[str] = None


SAMLVerificationErrorTypedDict = SAMLErrorClerkErrorTypedDict


SAMLVerificationError = SAMLErrorClerkError


class SamlTypedDict(TypedDict):
    status: SAMLVerificationStatus
    strategy: SAMLVerificationStrategy
    external_verification_redirect_url: Nullable[str]
    expire_at: int
    attempts: Nullable[int]
    error: NotRequired[Nullable[SAMLVerificationErrorTypedDict]]
    verified_at_client: NotRequired[Nullable[str]]


class Saml(BaseModel):
    status: SAMLVerificationStatus

    strategy: SAMLVerificationStrategy

    external_verification_redirect_url: Nullable[str]

    expire_at: int

    attempts: Nullable[int]

    error: OptionalNullable[SAMLVerificationError] = UNSET

    verified_at_client: OptionalNullable[str] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["error", "verified_at_client"]
        nullable_fields = [
            "external_verification_redirect_url",
            "attempts",
            "error",
            "verified_at_client",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


SAMLAccountVerificationTypedDict = TypeAliasType(
    "SAMLAccountVerificationTypedDict",
    Union[VerificationTicketTypedDict, SamlTypedDict],
)


SAMLAccountVerification = TypeAliasType(
    "SAMLAccountVerification", Union[VerificationTicket, Saml]
)


class SAMLConnectionSAMLConnectionTypedDict(TypedDict):
    id: str
    name: str
    domain: str
    active: bool
    provider: str
    sync_user_attributes: bool
    created_at: int
    r"""Unix timestamp of creation.

    """
    updated_at: int
    r"""Unix timestamp of last update.

    """
    allow_subdomains: NotRequired[bool]
    allow_idp_initiated: NotRequired[bool]
    disable_additional_identifications: NotRequired[bool]


class SAMLConnectionSAMLConnection(BaseModel):
    id: str

    name: str

    domain: str

    active: bool

    provider: str

    sync_user_attributes: bool

    created_at: int
    r"""Unix timestamp of creation.

    """

    updated_at: int
    r"""Unix timestamp of last update.

    """

    allow_subdomains: Optional[bool] = None

    allow_idp_initiated: Optional[bool] = None

    disable_additional_identifications: Optional[bool] = None


SamlConnectionTypedDict = SAMLConnectionSAMLConnectionTypedDict


SamlConnection = SAMLConnectionSAMLConnection


class SAMLAccountTypedDict(TypedDict):
    id: str
    object: SAMLAccountObject
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    provider: str
    active: bool
    email_address: str
    verification: Nullable[SAMLAccountVerificationTypedDict]
    first_name: NotRequired[Nullable[str]]
    last_name: NotRequired[Nullable[str]]
    provider_user_id: NotRequired[Nullable[str]]
    public_metadata: NotRequired[Dict[str, Any]]
    saml_connection: NotRequired[Nullable[SamlConnectionTypedDict]]


class SAMLAccount(BaseModel):
    id: str

    object: SAMLAccountObject
    r"""String representing the object's type. Objects of the same type share the same value.

    """

    provider: str

    active: bool

    email_address: str

    verification: Nullable[SAMLAccountVerification]

    first_name: OptionalNullable[str] = UNSET

    last_name: OptionalNullable[str] = UNSET

    provider_user_id: OptionalNullable[str] = UNSET

    public_metadata: Optional[Dict[str, Any]] = None

    saml_connection: OptionalNullable[SamlConnection] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "first_name",
            "last_name",
            "provider_user_id",
            "public_metadata",
            "saml_connection",
        ]
        nullable_fields = [
            "verification",
            "first_name",
            "last_name",
            "provider_user_id",
            "saml_connection",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
