"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .sessionactivityresponse import (
    SessionActivityResponse,
    SessionActivityResponseTypedDict,
)
from clerk_backend_api.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from enum import Enum
from pydantic import model_serializer
from typing_extensions import NotRequired, TypedDict


class SessionObject(str, Enum):
    r"""String representing the object's type. Objects of the same type share the same value."""

    SESSION = "session"


class ActorTypedDict(TypedDict):
    pass


class Actor(BaseModel):
    pass


class Status(str, Enum):
    ACTIVE = "active"
    REVOKED = "revoked"
    ENDED = "ended"
    EXPIRED = "expired"
    REMOVED = "removed"
    ABANDONED = "abandoned"
    REPLACED = "replaced"


class SessionTypedDict(TypedDict):
    object: SessionObject
    r"""String representing the object's type. Objects of the same type share the same value.

    """
    id: str
    user_id: str
    client_id: str
    status: Status
    last_active_at: int
    expire_at: int
    r"""Unix timestamp of expiration.

    """
    abandon_at: int
    r"""Unix timestamp of abandonment.

    """
    updated_at: int
    r"""Unix timestamp of last update.

    """
    created_at: int
    r"""Unix timestamp of creation.

    """
    actor: NotRequired[Nullable[ActorTypedDict]]
    last_active_organization_id: NotRequired[Nullable[str]]
    latest_activity: NotRequired[Nullable[SessionActivityResponseTypedDict]]


class Session(BaseModel):
    object: SessionObject
    r"""String representing the object's type. Objects of the same type share the same value.

    """

    id: str

    user_id: str

    client_id: str

    status: Status

    last_active_at: int

    expire_at: int
    r"""Unix timestamp of expiration.

    """

    abandon_at: int
    r"""Unix timestamp of abandonment.

    """

    updated_at: int
    r"""Unix timestamp of last update.

    """

    created_at: int
    r"""Unix timestamp of creation.

    """

    actor: OptionalNullable[Actor] = UNSET

    last_active_organization_id: OptionalNullable[str] = UNSET

    latest_activity: OptionalNullable[SessionActivityResponse] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["actor", "last_active_organization_id", "latest_activity"]
        nullable_fields = ["actor", "last_active_organization_id", "latest_activity"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
