"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from clerk_backend_api.types import BaseModel
from clerk_backend_api.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from enum import Enum
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ToggleTemplateDeliveryPathParamTemplateType(str, Enum):
    r"""The type of template to toggle delivery for"""

    EMAIL = "email"
    SMS = "sms"


class ToggleTemplateDeliveryRequestBodyTypedDict(TypedDict):
    delivered_by_clerk: NotRequired[bool]
    r"""Whether Clerk should deliver emails or SMS messages based on the current template"""


class ToggleTemplateDeliveryRequestBody(BaseModel):
    delivered_by_clerk: Optional[bool] = None
    r"""Whether Clerk should deliver emails or SMS messages based on the current template"""


class ToggleTemplateDeliveryRequestTypedDict(TypedDict):
    template_type: ToggleTemplateDeliveryPathParamTemplateType
    r"""The type of template to toggle delivery for"""
    slug: str
    r"""The slug of the template for which to toggle delivery"""
    request_body: NotRequired[ToggleTemplateDeliveryRequestBodyTypedDict]


class ToggleTemplateDeliveryRequest(BaseModel):
    template_type: Annotated[
        ToggleTemplateDeliveryPathParamTemplateType,
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""The type of template to toggle delivery for"""

    slug: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The slug of the template for which to toggle delivery"""

    request_body: Annotated[
        Optional[ToggleTemplateDeliveryRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None
